# remirepo/fedora spec file for php-kdyby-events
#
# Copyright (c) 2015-2017 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global gh_commit    f63b92eaf75df33d0a449af80de8e9f1d85dd6f6
#global gh_date      20150728
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     kdyby
%global gh_project   events
%global ns_vendor    Kdyby
%global ns_project   Events
%global php_home     %{_datadir}/php
%global with_tests   0%{!?_without_tests:1}

Name:           php-%{gh_owner}-%{gh_project}
Version:        3.1.0
%global specrel 2
Release:        %{?gh_date:1%{specrel}.%{?prever}%{!?prever:%{gh_date}git%{gh_short}}}%{!?gh_date:%{specrel}}%{?dist}
Summary:        Events for Nette Framework

Group:          Development/Libraries
License:        BSD or GPLv2 or GPLv3
URL:            https://github.com/%{gh_owner}/%{gh_project}
Source0:        %{name}-%{version}-%{gh_short}.tgz
# pull a git snapshot to get test sutie
Source1:        makesrc.sh
# Autoloader
Source2:        %{name}-autoload.php

Patch0:         %{name}-php72.patch

BuildArch:      noarch
%if %{with_tests}
BuildRequires:  php-pcre
BuildRequires:  php-spl
BuildRequires:  php-composer(nette/di) <  3
BuildRequires:  php-composer(nette/di) >= 2.3
BuildRequires:  php-composer(nette/utils) <  3
BuildRequires:  php-composer(nette/utils) >= 2.3
BuildRequires:  php-composer(nette/reflection) <  3
BuildRequires:  php-composer(nette/reflection) >= 2.3
BuildRequires:  php-composer(doctrine/common) <  3
BuildRequires:  php-composer(doctrine/common) >= 2.5.0
BuildRequires:  php-composer(fedora/autoloader)
# From composer.json, "require-dev": {
#               "nette/application": "^2.4@dev",
#               "nette/bootstrap": "^2.4@dev",
#               "nette/security": "^2.4@dev",
#               "nette/http": "^2.4@dev",
#               "tracy/tracy": "^2.4@dev",
#               "symfony/event-dispatcher": "^3.0",
#               "nette/tester": "~1.7"
BuildRequires:  php-composer(nette/application) <  3
BuildRequires:  php-composer(nette/application) >= 2.4
BuildRequires:  php-composer(nette/bootstrap) <  3
BuildRequires:  php-composer(nette/bootstrap) >= 2.4
BuildRequires:  php-composer(nette/security) <  3
BuildRequires:  php-composer(nette/security) >= 2.4
BuildRequires:  php-composer(nette/http) <  3
BuildRequires:  php-composer(nette/http) >= 2.4
BuildRequires:  php-composer(tracy/tracy) <  3
BuildRequires:  php-composer(tracy/tracy) >= 2.4
BuildRequires:  php-composer(nette/tester) >= 1.7
BuildRequires:  php-composer(symfony/event-dispatcher) <  4
BuildRequires:  php-composer(symfony/event-dispatcher) >= 3.0
%endif

# from composer.json, "require": {
#               "nette/di": "~2.4@dev",
#               "nette/utils": "~2.4@dev"
#               "nette/reflection": "^2.4@dev"
Requires:       php-composer(nette/di) >= 2.4
Requires:       php-composer(nette/di) <  3
Requires:       php-composer(nette/utils) >= 2.4
Requires:       php-composer(nette/utils) <  3
Requires:       php-composer(nette/reflection) >= 2.4
Requires:       php-composer(nette/reflection) <  3
# To avoid having to provide the compatibility layer
# version 2.5.0 for autoloader
Requires:       php-composer(doctrine/common) >= 2.5.0
Requires:       php-composer(doctrine/common) <  3
# For autoloader
Requires:       php-composer(fedora/autoloader)
# from phpcompatinfo report for version 2.4.0
Requires:       php-pcre
Requires:       php-spl

Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}


%description
This extension is here to provide robust events system for Nette Framework.

To use this library, you just have to add, in your project:
  require_once '%{php_home}/%{ns_vendor}/%{ns_project}/autoload.php';


%prep
%setup -q -n %{gh_project}-%{gh_commit}
%patch0 -p1

cp %{SOURCE2} src/%{ns_project}/autoload.php


%build
# Nothing


%install
mkdir -p                 %{buildroot}%{php_home}/%{ns_vendor}
cp -pr src/%{ns_project} %{buildroot}%{php_home}/%{ns_vendor}/%{ns_project}


%check
%if %{with_tests}
export LANG=fr_FR.utf8

: Generate autoloader
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/%{ns_vendor}/%{ns_project}/autoload.php';
\Fedora\Autoloader\Dependencies::required(array(
    '%{php_home}/Tester/autoload.php',
    '%{php_home}/Nette/Application/autoload.php',
    '%{php_home}/Nette/Bootstrap/autoload.php',
    '%{php_home}/Nette/Security/autoload.php',
    '%{php_home}/Nette/Http/autoload.php',
    '%{php_home}/Tracy/autoload.php',
    '%{php_home}/Symfony3/Component/EventDispatcher/autoload.php',
));
EOF

php -r 'require "%{buildroot}%{php_home}/%{ns_vendor}/%{ns_project}/autoload.php";'
php -r 'require "vendor/autoload.php";'

: Run test suite in sources tree
ret=0
# PHP 7.2: https://github.com/Kdyby/Events/issues/108
for cmd in php php56 php70 php71 php72; do
  if which $cmd; then
    $cmd %{_bindir}/nette-tester --colors 0 -p $cmd -C tests/KdybyTests -s || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license license.md
%doc README.md
%doc composer.json
%{php_home}/%{ns_vendor}


%changelog
* Thu Nov  9 2017 Remi Collet <remi@remirepo.net> - 3.1.0-2
- fix FTBFS from Koschei, add patch for PHP 7.2

* Mon May 15 2017 Remi Collet <remi@remirepo.net> - 3.1.0-1
- Update to 3.1.0
- add dependency on nette/reflection
- reduce build dependency to only needed components
- raise build dependency on Symfony 3
- raise dependency on nette 2.4

* Tue May  9 2017 Remi Collet <remi@fedoraproject.org> - 3.0.2-2
- switch to fedora/autoloader

* Thu Aug  4 2016 Remi Collet <remi@fedoraproject.org> - 3.0.2-1
- update to 3.0.2 (for nette 2.4)

* Thu Apr 21 2016 Remi Collet <remi@fedoraproject.org> - 2.4.1-1
- update to 2.4.1
- run test suite with both PHP 5 and 7 when available

* Sun Nov  1 2015 Remi Collet <remi@fedoraproject.org> - 2.4.0-1
- initial package
